Index: GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.vcproj	(revision 1926)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.vcproj	(revision 1936)
@@ -79,5 +79,5 @@
 				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\MultiLevelRayTracing"
-				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;NO_QT"
 				RuntimeLibrary="2"
 				RuntimeTypeInfo="TRUE"
@@ -193,5 +193,5 @@
 				OptimizeForProcessor="3"
 				OptimizeForWindowsApplication="TRUE"
-				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtGui&quot;"
+				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL;USE_QT"
 				RuntimeLibrary="2"
@@ -252,5 +252,5 @@
 				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;"
-				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL;NO_QT"
 				RuntimeLibrary="2"
 				RuntimeTypeInfo="TRUE"
@@ -266,64 +266,5 @@
 				OutputFile="../bin/release/Preprocessor.exe"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="..\src\GL;..\lib\release;..\..\Preprocessing\lib\release;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;..\MultiLevelRayTracing\RTScene\Release;..\MultiLevelRayTracing\RTWorld\Release;.\QtGlRenderer\Release"
-				GenerateDebugInformation="FALSE"
-				SubSystem="1"
-				OptimizeReferences="2"
-				EnableCOMDATFolding="2"
-				TargetMachine="1"
-				FixedBaseAddress="1"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"/>
-			<Tool
-				Name="VCWebDeploymentTool"/>
-			<Tool
-				Name="VCManagedWrapperGeneratorTool"/>
-			<Tool
-				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
-		</Configuration>
-		<Configuration
-			Name="Release_qt|Win32"
-			OutputDirectory="$(ConfigurationName)"
-			IntermediateDirectory="$(ConfigurationName)"
-			ConfigurationType="1"
-			CharacterSet="2">
-			<Tool
-				Name="VCCLCompilerTool"
-				Optimization="3"
-				GlobalOptimizations="TRUE"
-				InlineFunctionExpansion="2"
-				EnableIntrinsicFunctions="TRUE"
-				FavorSizeOrSpeed="1"
-				OptimizeForProcessor="0"
-				OptimizeForWindowsApplication="TRUE"
-				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\MultiLevelRayTracing;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtGui&quot;;.\QtGlRenderer"
-				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;USE_QT"
-				RuntimeLibrary="2"
-				RuntimeTypeInfo="TRUE"
-				UsePrecompiledHeader="0"
-				BrowseInformation="1"
-				WarningLevel="3"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLinkerTool"
-				AdditionalDependencies="xerces-c_2.lib glew32.lib zdll.lib zziplib.lib devil.lib glut32.lib OpenGL32.Lib glu32.lib Preprocessor.lib QtCore4.lib qtmain.lib QtOpenGL4.lib Qt3Support4.lib QtTest4.lib QtGui4.lib QtGlRenderer.lib"
-				OutputFile="../bin/release/Preprocessor.exe"
-				LinkIncremental="1"
-				AdditionalLibraryDirectories="..\src\GL;..\lib\release;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;&quot;$(QTDIR)\lib&quot;;.\QtGlRenderer\Release"
+				AdditionalLibraryDirectories="..\src\GL;..\lib\release;..\..\Preprocessing\lib\release;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;..\MultiLevelRayTracing\RTScene\Release;..\MultiLevelRayTracing\RTWorld\Release;&quot;$(QTDIR)\lib&quot;;.\QtGlRenderer\Release"
 				GenerateDebugInformation="FALSE"
 				SubSystem="1"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtGlViewer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtGlViewer.cpp	(revision 1931)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtGlViewer.cpp	(revision 1936)
@@ -1,4 +1,5 @@
 // ===================================================================
 // $Id$
+#ifdef USE_QT
 
 // Qt headers
@@ -160,6 +161,6 @@
 		{
 			scale = scale*(1.0f - dy/(float)height());
-			if (scale < 0.01)
-				scale = 0.01;
+			if (scale < 0.01f)
+				scale = 0.01f;
 			updateGL();
 		}
@@ -186,2 +187,4 @@
 }
 }
+
+#endif
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlRenderer.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlRenderer.vcproj	(revision 1926)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlRenderer.vcproj	(revision 1936)
@@ -40,5 +40,5 @@
 				OutputFile="$(OutDir)/QtGlRenderer.dll"
 				LinkIncremental="2"
-				AdditionalLibraryDirectories="&quot;$(QTDIR)\lib&quot;;..\..\..\..\..\..\NonGTP\Zlib\lib;&quot;$(CG_LIB_PATH)&quot;;..\src\GL;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;&quot;..\lib\$(ConfigurationName)&quot;"
+				AdditionalLibraryDirectories="..\..\lib\Debug;&quot;$(CG_LIB_PATH)&quot;;..\GL;&quot;..\lib\$(ConfigurationName)&quot;;&quot;$(QTDIR)\lib&quot;;..\..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\..\NonGTP\Zlib\lib"
 				GenerateDebugInformation="TRUE"
 				ProgramDatabaseFile="$(OutDir)/QtGlRenderer.pdb"
@@ -149,5 +149,5 @@
 				OutputFile="Release/QtGlRenderer.dll"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="&quot;$(QTDIR)\lib&quot;;..\..\..\..\..\..\..\NonGTP\Zlib\lib;&quot;$(CG_LIB_PATH)&quot;;..\..\src\GL;..\..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;&quot;..\..\lib\$(ConfigurationName)&quot;;..\..\MultiLevelRayTracing\RTScene\Release;..\..\MultiLevelRayTracing\RTWorld\Release"
+				AdditionalLibraryDirectories="&quot;$(QTDIR)\lib&quot;;..\..\..\..\..\..\..\NonGTP\Zlib\lib;&quot;$(CG_LIB_PATH)&quot;;..\..\src\GL;..\..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\lib\Release;..\..\MultiLevelRayTracing\RTScene\Release;..\..\MultiLevelRayTracing\RTWorld\Release"
 				GenerateDebugInformation="FALSE"
 				SubSystem="2"
@@ -162,4 +162,60 @@
 				Description="&quot;copy dll to preprocessor dir&quot;"
 				CommandLine="copy $(OutDir)\*.dll ..\..\bin\"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCWebDeploymentTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration
+			Name="Release Internal|Win32"
+			OutputDirectory="$(ConfigurationName)"
+			IntermediateDirectory="$(ConfigurationName)"
+			ConfigurationType="2"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories="..\..\src;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\..\..\..\..\..\..\NonGTP\Zlib\include;&quot;$(CG_INC_PATH)&quot;"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;QTGLRENDERER_EXPORTS"
+				RuntimeLibrary="2"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"
+				Description="Performing moc on $(InputName).h"
+				CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp
+"
+				Outputs="$(InputDir) moc_$(InputName).cpp"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="Preprocessor.lib qtmain.lib QtGui4.lib Qt3Support4.lib QAxContainer.lib QtCore4.lib QtOpenGL4.lib xerces-c_2.lib glew32.lib OpenGL32.Lib glu32.lib cg.lib cgGL.lib RTScene.lib RTWorld.lib"
+				OutputFile="Release/QtGlRenderer.dll"
+				LinkIncremental="1"
+				AdditionalLibraryDirectories="&quot;$(QTDIR)\lib&quot;;..\..\..\..\..\..\..\NonGTP\Zlib\lib;&quot;$(CG_LIB_PATH)&quot;;..\..\src\GL;..\..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\lib\Release;..\..\MultiLevelRayTracing\RTScene\Release;..\..\MultiLevelRayTracing\RTWorld\Release"
+				GenerateDebugInformation="FALSE"
+				SubSystem="2"
+				OptimizeReferences="2"
+				EnableCOMDATFolding="2"
+				ImportLibrary="$(OutDir)/QtGlRenderer.lib"
+				TargetMachine="1"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"
+				Description="&quot;copy dll to preprocessor dir&quot;"
+				CommandLine="copy Release\*.dll ..\..\bin\"/>
 			<Tool
 				Name="VCPreBuildEventTool"/>
@@ -191,14 +247,8 @@
 			</File>
 			<File
-				RelativePath=".\moc_QtGlViewer.cpp">
-			</File>
-			<File
 				RelativePath=".\QtGlRenderer.cpp">
 			</File>
 			<File
 				RelativePath=".\QtGlRendererDll.cpp">
-			</File>
-			<File
-				RelativePath=".\QtGlViewer.cpp">
 			</File>
 		</Filter>
@@ -227,13 +277,11 @@
 						Outputs="$(InputDir) moc_$(InputName).cpp"/>
 				</FileConfiguration>
-			</File>
-			<File
-				RelativePath=".\QtGlViewer.h">
 				<FileConfiguration
-					Name="Release|Win32">
+					Name="Release Internal|Win32">
 					<Tool
 						Name="VCCustomBuildTool"
 						Description="Performing moc on $(InputName).h"
-						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp"
+						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp
+"
 						Outputs="$(InputDir) moc_$(InputName).cpp"/>
 				</FileConfiguration>
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlRenderer.sln
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlRenderer.sln	(revision 1926)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlRenderer.sln	(revision 1936)
@@ -8,4 +8,5 @@
 		Debug = Debug
 		Release = Release
+		Release Internal = Release Internal
 		release_internal = release_internal
 	EndGlobalSection
@@ -15,4 +16,6 @@
 		{B85DC7B1-58B6-4912-BD64-8B452630A368}.Release.ActiveCfg = Release|Win32
 		{B85DC7B1-58B6-4912-BD64-8B452630A368}.Release.Build.0 = Release|Win32
+		{B85DC7B1-58B6-4912-BD64-8B452630A368}.Release Internal.ActiveCfg = Release Internal|Win32
+		{B85DC7B1-58B6-4912-BD64-8B452630A368}.Release Internal.Build.0 = Release Internal|Win32
 		{B85DC7B1-58B6-4912-BD64-8B452630A368}.release_internal.ActiveCfg = release_internal|Win32
 		{B85DC7B1-58B6-4912-BD64-8B452630A368}.release_internal.Build.0 = release_internal|Win32
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlViewer.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlViewer.h	(revision 1926)
+++ 	(revision )
@@ -1,55 +1,0 @@
-#ifndef __QTGLVIEWER_H
-#define __QTGLVIEWER_H
-
-#include <QtOpenGL>
-#include <QWaitCondition>
-
-namespace GtpVisibilityPreprocessor {
-
-class QtGlRendererWidget;
-
-
-class __declspec(dllexport) QtGlViewer: public QGLWidget
-{	
-	//Q_OBJECT
-
-public:
-	
-	QtGlViewer(QWidget *parent, QtGlRendererWidget *renderer);
-
-	virtual ~QtGlViewer() {};
-
-	QSize minimumSizeHint() const;
-	QSize sizeHint() const;
-
-	// This method has to be rendefined by all renderer implementations
-	virtual void RenderScene();
-
-	QtGlRendererWidget *mRenderer;
-
-protected:
-
-	void initializeGL();
-	void paintGL();
-	void resizeGL(int width, int height);
-	void mousePressEvent(QMouseEvent *event);
-	void mouseMoveEvent(QMouseEvent *event);
-
-	void keyPressEvent ( QKeyEvent * e );
-
-	bool mWireframe;
-
-private:
-
-	float manipulatorLastQuat[4];
-	float scale;
-	
-	QPoint lastPos;
-
-	friend class QtGlRendererWidget;
-	friend class GlRenderer;
-};
-
-}
-
-#endif
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlViewer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlViewer.cpp	(revision 1926)
+++ 	(revision )
@@ -1,187 +1,0 @@
-// ===================================================================
-// $Id$
-
-// Qt headers
-#include <QtGui>
-#include <QtOpenGL>
-
-// C++ standard headers
-//#include <cmath>
-
-// local headers
-#include "common.h"
-#include "QtGlViewer.h"
-#include "QtGlRenderer.h"
-#include "Trackball.h"
-#include "RssPreprocessor.h"
-#include "SceneGraph.h"
-
-
-namespace GtpVisibilityPreprocessor {
-
-QtGlRendererWidget *renderer;
-
-QtGlViewer::QtGlViewer(QWidget *parent,
-					   QtGlRendererWidget *renderer):
-  QGLWidget(parent), mRenderer(renderer)
-{
-	scale = 1.0f;
-	mWireframe = false;
-	trackball(manipulatorLastQuat, 0.0f, 0.0f, 0.0f, 0.0f);
-	connect(renderer, SIGNAL(PvsUpdated()), this, SLOT(updateGL()));
-}
-  
-QSize
-QtGlViewer::minimumSizeHint() const
-{
-  return QSize(100, 100);
-}
-
-QSize
-QtGlViewer::sizeHint() const {
-  return QSize(500, 500);
-}
-  
-// This method has to be rendefined by all renderer implementations
-void
-QtGlViewer::RenderScene()
-{
-	mRenderer->mFrame++;
-	
-	// render into the right side of the window buffer
-	if (mRenderer->mRenderViewCells) 
-	  mRenderer->RenderViewCells();
-	
-	mRenderer->RenderPvs();
-	
-// 	if (mRenderer->mShowRays) {
-// 	  RssPreprocessor *p = (RssPreprocessor *)
-// 			mRenderer->mViewCellsManager->GetPreprocessor();
-// 	  if (p->mRssTree) {
-// 			VssRayContainer rays;
-// 			p->mRssTree->CollectRays(rays, 10000);
-// 			mRenderer->RenderRays(rays);
-// 	  }
-// 	}
-	
-	if (mRenderer->mShowRenderCost) 
-	  mRenderer->RenderRenderCost();
-
-	glColor3f(1.0f, 1.0f, 1.0f);
-	mRenderer->RenderInfo();
-}
-
-
-void
-QtGlViewer::initializeGL()
-{  
-  const char *vendorString, *rendererString, *versionString, *extString;
-
-  // get GL info
-  vendorString = (const char *) glGetString(GL_VENDOR);
-  rendererString = (const char *) glGetString(GL_RENDERER);
-  versionString = (const char *) glGetString(GL_VERSION);
-  extString = (const char *) glGetString(GL_EXTENSIONS);
-  
-  Debug << "Info: GL Vendor = "<<vendorString<<endl
-        << "Info: GL Renderer = "<<rendererString<<endl
-        << "Info: GL Version = "<<versionString<<endl
-        << "Info: GL Extensions = "<<extString<<endl<<flush;
-
-
-  return;
-}
-
-void
-QtGlViewer::paintGL()
-{
-  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
-  glLoadIdentity();
-
-  float m[4][4];
-
-  glLoadIdentity();
-  gluLookAt(0.0, 0.0, 1.0,  /* eye is at (0,0,30) */
-						0.0, 0.0, 0.0,      /* center is at (0,0,0) */
-						0.0, 1.0, 0.);      /* up is in positive Y direction */
-  
-  build_rotmatrix(m, manipulatorLastQuat);
-  glMultMatrixf(&m[0][0]);
-
-  float s = scale*20.0f/Magnitude(mRenderer->mSceneGraph->GetBox().Diagonal());
-  glScalef(s, s, s);
-  
-  Vector3 t = -mRenderer->mSceneGraph->GetBox().Center();
-  glTranslatef(t.x, t.y, t.z);
-
-	RenderScene();
-}
-
-void
-QtGlViewer::resizeGL(int width, int height)
-{
-  glViewport(0, 0, width, height);
-  
-  glMatrixMode(GL_PROJECTION);
-  glLoadIdentity();
-  gluPerspective(70.0, 1.0, 0.1, 100.0);
-  //  glOrtho(-0.5*width/height, +0.5*width/height, 0.5, -0.5, 4.0, 15.0);
-  glMatrixMode(GL_MODELVIEW);
-}
-
-
-void
-QtGlViewer::mousePressEvent(QMouseEvent *event)
-{
-  lastPos = event->pos();
-}
-
-void
-QtGlViewer::keyPressEvent ( QKeyEvent * e )
-{
-  switch (e->key()) {
-  case Qt::Key_W:
-		mWireframe  = !mWireframe;
-		updateGL();
-  default:
-		e->ignore();
-		break;
-  }
-  updateGL();
-}
-
-void
-QtGlViewer::mouseMoveEvent(QMouseEvent *event)
-{
-  int dx = event->x() - lastPos.x();
-  int dy = event->y() - lastPos.y();  
-  
-  if (event->modifiers() & Qt::CTRL)
-		{
-			scale = scale*(1.0f - dy/(float)height());
-			if (scale < 0.01)
-				scale = 0.01;
-			updateGL();
-		}
-  else {
-		float W = width();
-		float H = height();
-		int x = event->x();
-		int lastX = lastPos.x();
-		int y = event->y();
-		int lastY = lastPos.y();
-	
-		float quat[4];
-		trackball(quat,
-							(2.0 * lastX - W) / W,
-							(H - 2.0 * lastY) / H,
-							(2.0 * x - W) / W,
-							(H - 2.0 * y) / H
-							);
-		add_quats(quat, manipulatorLastQuat, manipulatorLastQuat);
-  }
-  
-  lastPos = event->pos();
-updateGL();
-}
-}
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj	(revision 1926)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj	(revision 1936)
@@ -217,6 +217,6 @@
 				OptimizeForProcessor="3"
 				OptimizeForWindowsApplication="TRUE"
-				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;"
-				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL"
+				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;USE_QT"
 				ExceptionHandling="TRUE"
 				RuntimeLibrary="2"
@@ -283,57 +283,4 @@
 				Name="VCLibrarianTool"
 				OutputFile="../lib/Release/$(ProjectName).lib"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"/>
-			<Tool
-				Name="VCManagedWrapperGeneratorTool"/>
-			<Tool
-				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
-		</Configuration>
-		<Configuration
-			Name="Release_qt|Win32"
-			OutputDirectory="$(ConfigurationName)"
-			IntermediateDirectory="$(ConfigurationName)"
-			ConfigurationType="4"
-			CharacterSet="2">
-			<Tool
-				Name="VCCLCompilerTool"
-				Optimization="3"
-				GlobalOptimizations="TRUE"
-				InlineFunctionExpansion="2"
-				EnableIntrinsicFunctions="TRUE"
-				FavorSizeOrSpeed="1"
-				OmitFramePointers="TRUE"
-				EnableFiberSafeOptimizations="TRUE"
-				OptimizeForProcessor="0"
-				OptimizeForWindowsApplication="TRUE"
-				AdditionalIncludeDirectories="..\include;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;"
-				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;USE_QT"
-				ExceptionHandling="TRUE"
-				RuntimeLibrary="2"
-				DisableLanguageExtensions="FALSE"
-				ForceConformanceInForLoopScope="FALSE"
-				RuntimeTypeInfo="TRUE"
-				UsePrecompiledHeader="0"
-				BrowseInformation="1"
-				WarningLevel="2"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLibrarianTool"
-				OutputFile="..\lib\Release\$(ProjectName).lib"/>
 			<Tool
 				Name="VCMIDLTool"/>
@@ -639,12 +586,4 @@
 						Outputs=""/>
 				</FileConfiguration>
-				<FileConfiguration
-					Name="Release_qt|Win32">
-					<Tool
-						Name="VCCustomBuildTool"
-						Description=""
-						CommandLine=""
-						Outputs=""/>
-				</FileConfiguration>
 			</File>
 			<File
@@ -699,12 +638,4 @@
 						Outputs=""/>
 				</FileConfiguration>
-				<FileConfiguration
-					Name="Release_qt|Win32">
-					<Tool
-						Name="VCCustomBuildTool"
-						Description=""
-						CommandLine=""
-						Outputs=""/>
-				</FileConfiguration>
 			</File>
 			<File
@@ -713,4 +644,10 @@
 			<File
 				RelativePath="..\src\Pvs.h">
+			</File>
+			<File
+				RelativePath=".\QtGlViewer.cpp">
+			</File>
+			<File
+				RelativePath=".\QtGlViewer.h">
 			</File>
 			<File
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtGlViewer.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtGlViewer.h	(revision 1931)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtGlViewer.h	(revision 1936)
@@ -2,4 +2,5 @@
 #define __QTGLVIEWER_H
 
+#ifdef USE_QT
 #include <QtOpenGL>
 
@@ -12,5 +13,5 @@
 {
 	
-	Q_OBJECT
+	//Q_OBJECT
 
 	friend class QtGlRendererWidget;
@@ -53,2 +54,3 @@
 
 #endif
+#endif